#!/usr/bin/python3

import sys

from PyQt5.QtCore import QUrl
from PyQt5.QtGui import QGuiApplication
from PyQt5.QtQml import qmlRegisterType
from PyQt5.QtQuick import QQuickView
from PyQt5.QtMultimedia import (QVideoFilterRunnable,
    QAbstractVideoFilter, QVideoFrame, QVideoSurfaceFormat)


class MyFilterRunnable(QVideoFilterRunnable):
    def run(self, input: QVideoFrame, surfaceFormat: QVideoSurfaceFormat, flags) :
        return input

class MyFilter(QAbstractVideoFilter):
    def createFilterRunnable(self) :
        return MyFilterRunnable()

if __name__ == "__main__":
    app = QGuiApplication(sys.argv)
    view = QQuickView()
    view.setResizeMode(QQuickView.SizeRootObjectToView)

    qmlRegisterType(MyFilter, 'myuri', 1, 0, "MyFilter")

    # Load the QML file
    view.setSource(QUrl.fromLocalFile("case.qml"))

    # Show the window
    if view.status() == QQuickView.Error:
        sys.exit(-1)
    view.show()

    # Execute and cleanup
    app.exec_()
    del view
